package infomat.vectorspace;

import mro.util.measures.*;


import java.util.*;

/**
 * A class for sorting of IObjectGroupings in order of 
 * associated Measure:s.
 *
 * @version          080218
 * @author           Magnus Rosell
 */
public class MeasureSorter{

    public static void sortGroupingByGroupMeasureMap(IObjectGrouping ioging, HashMap<IObjectGroup, Measure> groupMeasureMap, boolean descending){

	Vector<IObjectGroup> iogvec = ioging.getGroups();
	GroupMeasureComparator gmc = (new MeasureSorter()).new GroupMeasureComparator(groupMeasureMap);
	Collections.sort(iogvec, gmc);
	if(!descending)
	    Collections.reverse(iogvec);
		
	ioging.setGroups(iogvec);
    }



    private class GroupMeasureComparator implements Comparator{

	HashMap<IObjectGroup, Measure> groupMeasureMap;

	public GroupMeasureComparator(HashMap<IObjectGroup, Measure> groupMeasureMap){	
	    this.groupMeasureMap=groupMeasureMap;
	}
		
	public int compare(Object o1, Object o2) {
			
	    double val1 = groupMeasureMap.get((IObjectGroup) o1).getValue();
	    double val2 = groupMeasureMap.get((IObjectGroup) o2).getValue();
	    if(val1>val2)
		return -1;
	    else if(val2>val1)
		return 1;
	    else
		return 0;

	}
    }

}
