package infomat.vectorspace;

import java.util.*;

/**
 * A SoftIObjectGrouping 
 *
 * @version          080605
 * @author           Magnus Rosell
 */
public class SoftIObjectGrouping extends IObjectGroup
{
    private static int softGroupingMaxIdSoFar=0;

    private HashMap<IObject, HashMap<Integer, Float>> ioGroupValueMap = 
	new HashMap<IObject, HashMap<Integer, Float>>();

    public SoftIObjectGrouping(String groupingName){
	super(groupingName, 2, ++softGroupingMaxIdSoFar);
    }

    
    public static IMatrix
	projectIObjectsOnGroups(IObjectGrouping grouping, ISimilarity sim){
	
	IMatrix matrix = new IMatrix("dummy col", "dummy row");


	Vector<IObjectGroup> groups = grouping.getGroups();
	Vector<IObject, Float> groupReprs = 
	    new Vector<IObject, Float>();

	for(int i=0; i<groups.size(); i++){
	    IObjectGroup iog = groups.elementAt(i);
	    groupReprs.add(sim.getGroupRepresentation(iog));

	    matrix.addColumnIObject(iog);
	}


	Vector<IObject> ios = grouping.getOrdered();
	
	for(int i=0; i<ios.size(); i++){
	    IObject io = ios.elementAt(i);
	    matrix.addRowIObject(io);

	    HashMap<IObject, Float> ior = sim.getRepresentation(io);
	    for(int j=0; j<groupReprs.size(); j++){
		HashMap<IObject, Float> iogr = groupReprs.elementAt(j);
		float sim = sim.sim(ior, iogr);
		
		IMatrixCell mc = 
		    new IMatrixCell(io, groups.elementAt(j), sim);
		matrix.addCell(mc);
	    }
	}
	
	Normalizer normalizer = new Normalizer();
	boolean row = true;
	normalizer.normalize(matrix, row);

	return matrix;
    }

    public IObjectGrouping getHardGrouping(){
	
    }




}

