package infomat.view.evaluation;

import infomat.vectorspace.*;
import infomat.view.*;
import infomat.view.grouping.settings.GroupingSettingsManager;
import infomat.view.grouping.settings.GroupingColoring;
import infomat.view.grouping.settings.GroupingSettingsPanel;

import javax.swing.*;

import java.awt.event.*;
import java.awt.*;
import java.util.*;


/**
 * Displayer of info.
 * @see EvaluationFrame
 */
public class EvaluationSelectionPanel extends JPanel
    implements ActionListener, Observer{
    //    implements Observer{

    private static String none="None";

    //private InfomatModel model;
    private InfomatView view;
    private IObjectSet ios;
    private boolean colorPanel;
    private boolean rowPanel; // Row or column

    private JComboBox cBox;
    private JButton button;

    private String selected;
    private String groupingSelection;

    private JFrame settingsFrame = null;

    public EvaluationSelectionPanel(InfomatView view, String groupingSelection){
	//this.model=model;
	this.view=view;
	selected=none;
	this.groupingSelection=groupingSelection;
	
	view.getInfomatModel().addObserver(this);
	
	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    }

    public boolean actionLeadToChange(){
	String newSelected = (String) cBox.getSelectedItem();
	System.out.println("newSelected: "+newSelected);
	if(selected != newSelected){
	    selected = newSelected;
	    return true;
	}
	return false;
    }

    public IObjectGrouping getSelectedGrouping(){
	if(selected.equals(none))
	    return null;
	return ios.getGroupingWithName(selected);
    }


    //public void paintComponent(Graphics g) {
    //super.paintComponent(g);
    //}

    private boolean first=true;

    public void makeComboBox(IObjectSet ios){
	if(ios==null)
	    return;

	this.ios=ios;
	removeAll();
	Vector<IObjectGrouping> groupings = ios.getGroupings();
	if(groupings != null && groupings.size()>0){
	    Vector<String> strings = new Vector<String>();

	    strings.add(none);
	    for(int i=0; i<groupings.size(); i++)
		strings.add(groupings.elementAt(i).getName());

	    cBox = new JComboBox(strings);
			
	    if(first){
		selected = groupings.elementAt(0).getName();
		first=false;
	    }

	    /*
	    JTextField dummyTextField = new JTextField("123");
	    int height = (int) dummyTextField.getPreferredSize().getHeight();
	    Dimension d = new Dimension((int)cBox.getPreferredSize().getWidth(), height);

	    cBox.setPreferredSize(d);
	    cBox.setMinimumSize(d);
	    cBox.setMaximumSize(d);
	    */
	
	    cBox.setSelectedItem(selected);
	}


	//	JLabel l = new JLabel(groupingSelection);


	cBox.setPrototypeDisplayValue("Clustering of some things");

	/*
	add(l);
	l.setAlignmentX(LEFT_ALIGNMENT);
	*/

	add(cBox);
	cBox.setAlignmentX(LEFT_ALIGNMENT);
	cBox.addActionListener(this);


	revalidate();
	repaint();
    }
	
    public IObjectGrouping getCurrentGrouping(){
	String newSelected = (String) cBox.getSelectedItem();
	return ios.getGroupingWithName(newSelected);
    }

    public void actionPerformed(ActionEvent e) {

	// Detta r bara fr evaluering.
	// Varfr skulle man vilja ndra bilden?

	// ComboBox
	if(e.getSource() instanceof JComboBox){    	    
	    actionLeadToChange();
	}

	/*
	if(e.getSource() instanceof JComboBox){    	    
	    if(actionLeadToChange()){
		ios.setGrouping(ios.getGroupingWithName(selected));
		view.resetImage();
		view.forceChange();
	    }
	}
	*/
    }

    public JComboBox getComboBox(){
	return cBox;
    }

    public JButton getButton(){
	return button;
    }



    /** Called by the Observable */
    public void update(Observable o, Object arg) {
	makeComboBox(ios);
	//	putAll();
    }



}


