package infomat.view.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * A JButton that can be initialized to alter its text between
 * the strings of a string-array when pressed.
 *
 * @version          080409
 * @author           Magnus Rosell
 */
public class AlternatingButton extends JButton{

    private String[] strings = null;
    private int currentStringNumber = -1;

    public AlternatingButton(String[] strings){
	this.strings = strings;

	fixSize();

	press();
    }

    private void fixSize(){
	String string = longestString();
	JTextField dummy = new JTextField(string);
	JButton dummyButton = new JButton(string);
	int height = (int) dummy.getPreferredSize().getHeight();
	int width = (int) dummyButton.getPreferredSize().getWidth();
	Dimension buttonSize = new Dimension(width, height);
	setPreferredSize(buttonSize);
	setMaximumSize(buttonSize);
    }

    private String longestString(){
	String longest = strings[0];
	for(int i=0; i<strings.length; i++){
	    if(strings[i].length() > longest.length())
		longest = strings[i];
	}
	return longest;
    }


    public void press(){
	currentStringNumber++;
	if(currentStringNumber == strings.length)
	    currentStringNumber = 0;
	String string = strings[currentStringNumber];
	setText(string);
    }
}
	
