package infomat.view.vector;

import infomat.io.*;
import infomat.vectorspace.vector.*;
import infomat.view.*;
import infomat.view.util.*;

import mro.util.*;
import mro.util.doublehashmap.DoubleHashMap;

import java.io.*;
import java.util.*;
import java.awt.Dimension;

import java.awt.*;
import java.awt.event.*;
import java.net.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;


/**
 * @version          080704
 * @author           Magnus Rosell
 */
public class IVectorIndexPanel<T extends IVectorIndex> 
    extends JPanel implements ActionListener{

    private int number;
    private T index;
    private float value;
    private boolean selectable;
    private InfomatModel model;
    //    private String browserName;

    private JCheckBox cb;
    private SmallButton locationB;

    private boolean showValue = true;

    public IVectorIndexPanel(int number, 
			     T index, float value, 
			     boolean selectable, 
			     InfomatModel model){
	this.number=number;
	this.index=index;
	this.value=value;
	this.selectable=selectable;
	this.model=model;

	//	browserName = (String) model.getPropertyValue("Browser");

	putAll();
    }

    public void setShowValue(boolean showValue){
	this.showValue=showValue;
	putAll();
    }

    private void putAll(){
	removeAll();
	
	JPanel panel = new JPanel();
	setLayout(new FlowLayout(FlowLayout.LEFT));
	//	panel.setLayout(new FlowLayout(FlowLayout.LEFT));
	panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
	
	String str = number+". ";
	JLabel label = new JLabel(str);
	panel.add(label);

	if(index.getLocation()!=null && 
	   model!=null){ 
	    //	    && Desktop.isDesktopSupported()){
	    str = index.getString();
	    locationB = new SmallButton(str);
	    locationB.addActionListener(this);
	    panel.add(locationB);
	}else{
	    str = index.getString();
	    label = new JLabel(str);
	    panel.add(label);
	}

	if(showValue){
	    str = ", "+value;
	    label = new JLabel(str);
	    panel.add(label);
	}
	
	if(selectable){
	    cb = new JCheckBox();
	    panel.add(cb);
	}else
	    cb = null;

	add(panel);
	panel.setMaximumSize(panel.getPreferredSize());
	panel.setMinimumSize(panel.getPreferredSize());

	revalidate();
	repaint();
    }

    public boolean isSelected(){
	if(cb!=null)
	    return cb.isSelected();
	return false;
    }

    public void setSelected(boolean b){
	if(cb!=null)
	    cb.setSelected(b);
    }

    public T getIVectorIndex(){
	return index;
    }


    
    private static FileViewer fw;

    public void actionPerformed(ActionEvent e) {
	if(e.getSource() instanceof JButton){
	    JButton source = (JButton) e.getSource();
	    if(source == locationB){
		//		if(model!=null){
		    //		    System.out.println(index.getLocation());
		    //		    String command = browserName+" "+index.getLocation(); //+" &";
		    //		    runnableThread = new RunnableThread("hej", command); 

		    try{
			File f = new File(index.getLocation());
			fw = new FileViewer(f.getCanonicalPath());
		    }catch(IOException io){
			System.out.println("Unable to open viewer!");
			System.out.println();
		    }
		    /*
		    try{
			browserProcess = Runtime.getRuntime().exec(command);
		    }catch(IOException io){
			System.out.println("Unable to open browser!");
			io.printStackTrace(System.out);
			System.out.println();
			System.out.println("command: ");
			System.out.println(command);
		    }
		    */
		    //		}
	    }
	}
    }


  

}
